import 'package:barback/barback.dart';

class CompileTemplates extends Transformer {
  final BarbackSettings _settings;

  CompileTemplates.asPlugin(this._settings);

  String get allowedExtensions => ".jade";

  Future<bool> isPrimary(AssetId id) {
    return new Future.value(id.path.startsWith('views/');
  }

  String copyright = 'aaa\n';

  Future apply(Transform transform) {
    new AssetId("package", "some/path.ext");
    return transform.primaryInput.readAsString().then((content) {
      var id = transform.primaryInput.id;
      String newContent = copyright + content;
      transform.addOutput(new Asset.fromString(id, newContent));
    });
  }
}
